/*
 * Copyright (c) 2001-2007 International Computer Science Institute
 * See LICENSE file for licensing, conditions, and warranties on use.
 *
 * DO NOT EDIT THIS FILE - IT IS PROGRAMMATICALLY GENERATED
 *
 * Generated by 'tgt-gen'.
 *
 * $XORP: xorp/xrl/targets/xorpsh_base.hh,v 1.20 2007/02/16 22:48:00 pavlin Exp $
 */


#ifndef __XRL_TARGETS_XORPSH_BASE_HH__
#define __XRL_TARGETS_XORPSH_BASE_HH__

#undef XORP_LIBRARY_NAME
#define XORP_LIBRARY_NAME "XrlXorpshTarget"

#include "libxorp/xlog.h"
#include "libxipc/xrl_cmd_map.hh"

class XrlXorpshTargetBase {
protected:
    XrlCmdMap* _cmds;

public:
    /**
     * Constructor.
     *
     * @param cmds an XrlCmdMap that the commands associated with the target
     *		   should be added to.  This is typically the XrlRouter
     *		   associated with the target.
     */
    XrlXorpshTargetBase(XrlCmdMap* cmds = 0);

    /**
     * Destructor.
     *
     * Dissociates instance commands from command map.
     */
    virtual ~XrlXorpshTargetBase();

    /**
     * Set command map.
     *
     * @param cmds pointer to command map to associate commands with.  This
     * argument is typically a pointer to the XrlRouter associated with the
     * target.
     *
     * @return true on success, false if cmds is null or a command map has
     * already been supplied.
     */
    bool set_command_map(XrlCmdMap* cmds);

    /**
     * Get Xrl instance name associated with command map.
     */
    inline const string& name() const { return _cmds->name(); }

    /**
     * Get version string of instance.
     */
    inline const char* version() const { return "xorpsh/0.0"; }

protected:

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Get name of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_target_name(
	// Output values,
	string&	name) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Get version string from Xrl Target
     */
    virtual XrlCmdError common_0_1_get_version(
	// Output values,
	string&	version) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Get status of Xrl Target
     */
    virtual XrlCmdError common_0_1_get_status(
	// Output values,
	uint32_t&	status,
	string&	reason) = 0;

    /**
     *  Pure-virtual function that needs to be implemented to:
     *
     *  Request clean shutdown of Xrl Target
     */
    virtual XrlCmdError common_0_1_shutdown() = 0;

    virtual XrlCmdError rtrmgr_client_0_2_new_config_user(
	// Input values,
	const uint32_t&	userid) = 0;

    virtual XrlCmdError rtrmgr_client_0_2_config_saved_done(
	// Input values,
	const bool&	success,
	const string&	errmsg) = 0;

    virtual XrlCmdError rtrmgr_client_0_2_config_change_done(
	// Input values,
	const bool&	success,
	const string&	errmsg) = 0;

    virtual XrlCmdError rtrmgr_client_0_2_config_changed(
	// Input values,
	const uint32_t&	userid,
	const string&	deltas,
	const string&	deletions) = 0;

    virtual XrlCmdError rtrmgr_client_0_2_module_status(
	// Input values,
	const string&	modname,
	const uint32_t&	status) = 0;

private:
    const XrlCmdError handle_common_0_1_get_target_name(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_get_version(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_get_status(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_common_0_1_shutdown(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_rtrmgr_client_0_2_new_config_user(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_rtrmgr_client_0_2_config_saved_done(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_rtrmgr_client_0_2_config_change_done(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_rtrmgr_client_0_2_config_changed(const XrlArgs& in, XrlArgs* out);

    const XrlCmdError handle_rtrmgr_client_0_2_module_status(const XrlArgs& in, XrlArgs* out);

    void add_handlers();
    void remove_handlers();
};

#endif // __XRL_TARGETS_XORPSH_BASE_HH__
